<?php

namespace Xfrocks\AttachmentStore\Cli\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * @see \Xfrocks\AttachmentStore\Job\Move
 */
class Move extends Command
{
    use \XF\Cli\Command\JobRunnerTrait;

    /**
     * @return void
     */
    protected function configure()
    {
        $this
            ->setName('attachment-store:move')
            ->setDescription('Move attachment data')
            ->addArgument(
                'start',
                InputArgument::OPTIONAL,
                'The data_id to start moving from',
                0
            )
            ->addOption(
                'backup-path',
                'p',
                InputOption::VALUE_OPTIONAL,
                'If provided, the add-on will try to use data file in this directory ' .
                'in case the file path built from database record is not available.'
            )
            ->addOption(
                'modulo',
                'm',
                InputOption::VALUE_OPTIONAL,
                'Format: n,m (n comma m). If provided, data_id modulo n must be m or it will be skipped.'
            );
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $this->setupAndRunJob(
            __CLASS__,
            'Xfrocks\AttachmentStore:Move',
            [
                'start' => intval($input->getArgument('start')),
                'backupPath' => strval($input->getOption('backup-path')),

                'isCli' => true,
                'modulo' => strval($input->getOption('modulo')),
            ]
        );

        return 0;
    }
}
