<?php

namespace Xfrocks\AttachmentStore\FsAdapter;

use CedricZiel\FlysystemGcs\GoogleCloudStorageAdapter;
use League\Flysystem\Config;

class GcsAdapter extends GoogleCloudStorageAdapter
{
    public function writeStream($path, $resource, Config $config)
    {
        $stream = \GuzzleHttp\Psr7\stream_for($resource);
        $result = $this->writeObject($path, $stream, $config);

        // TODO: remove this when google/cloud-storage stops closing the resource by itself
        $stream->detach();

        return $result;
    }

    public function updateStream($path, $resource, Config $config)
    {
        return $this->writeStream($path, $resource, $config);
    }
}
