<?php

namespace Xfrocks\AttachmentStore\Job;

use XF\Job\AbstractJob;
use Xfrocks\AttachmentStore\Data\Storage;

class DelayQueue extends AbstractJob
{
    public function run($maxRunTime)
    {
        /** @var Storage $storage */
        $storage = $this->app->data('Xfrocks\AttachmentStore:Storage');
        $queue = $storage->delayQueue($this->app->db());

        $queue->run($this->app, $maxRunTime);

        if ($queue->hasMore()) {
            return $this->resume();
        } else {
            return $this->complete();
        }
    }

    /**
     * @return string
     */
    public function getStatusMessage()
    {
        return '';
    }

    /**
     * @return bool
     */
    public function canCancel()
    {
        return false;
    }

    /**
     * @return bool
     */
    public function canTriggerByChoice()
    {
        return false;
    }
}
