<?php

namespace Xfrocks\AttachmentStore\XF\ControllerPlugin;

use Xfrocks\AttachmentStore\Data\Storage;
use Xfrocks\AttachmentStore\XF\Entity\AttachmentData;

class Attachment extends XFCP_Attachment
{
    /**
     * @param \XF\Entity\Attachment $attachment
     * @param mixed $allowViewLog
     * @return \XF\Mvc\Reply\AbstractReply
     */
    public function displayAttachment(\XF\Entity\Attachment $attachment, $allowViewLog = true)
    {
        /** @var AttachmentData $attachmentData */
        $attachmentData = $attachment->Data;

        if (strlen($attachmentData->bdattachmentstore_engine) > 0) {
            /** @var Storage $storage */
            $storage = $this->app->data('Xfrocks\AttachmentStore:Storage');
            $filePath = $storage->getFilePathData($attachmentData);
            $fileUrl = $storage->getFileUrlWithAttachmentData($attachmentData, $filePath);

            return $this->redirect($fileUrl);
        }

        return parent::displayAttachment($attachment, $allowViewLog);
    }
}
