<?php

namespace Xfrocks\AttachmentStore\XF\Pub\Controller;

use XF\Mvc\ParameterBag;
use Xfrocks\AttachmentStore\Data\Storage;

class Attachment extends XFCP_Attachment
{
    /**
     * @var bool
     */
    private $xfrocksAttachmentStoreIsActionIndex = false;

    /**
     * @param ParameterBag $params
     * @return \XF\Mvc\Reply\Error|\XF\Mvc\Reply\View
     * @throws \XF\Mvc\Reply\Exception
     */
    public function actionIndex(ParameterBag $params)
    {
        $this->xfrocksAttachmentStoreIsActionIndex = true;

        return parent::actionIndex($params);
    }

    /**
     * @param string $linkUrl
     * @return void
     * @throws \XF\Mvc\Reply\Exception
     */
    public function assertCanonicalUrl($linkUrl)
    {
        if ($this->xfrocksAttachmentStoreIsActionIndex) {
            /** @var Storage $storage */
            $storage = $this->data('Xfrocks\AttachmentStore:Storage');
            if ($storage->isOurUrl($linkUrl)) {
                throw $this->exception($this->redirectPermanently($linkUrl));
            }
        }

        parent::assertCanonicalUrl($linkUrl);
    }
}
